﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode
{
    [StorableClass]
    public class Program : Symbol
    {
        public override int MinimumArity { get { return 2; } }
        public override int MaximumArity { get { return byte.MaxValue; } }

        [StorableConstructor]
        private Program(bool deserializing) : base(deserializing) { }
        private Program(Program original, Cloner cloner)
            : base(original, cloner)
        {
        }

        public Program()
            : base("Program", "A Robocode tank program.")
        {
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new Program(this, cloner);
        }
    }
}